//  
//  SoftBank X}[gtHT[rXJxTCg
//  t@XR[h12(Bluetooth)
//
//  Copyright(c) 2011 SOFTBANK MOBILE Corp. All rights reserved
//

package com.example.bluetoothsample;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.view.View;
import android.view.View.OnClickListener;

public class BluetoothSample extends Activity {
	// AndroidManifest
	// PermissionsɈȉ̓eǉĂ
	// android.permission.BLUETOOTH_ADMIN
	// android.permission.BLUETOOTH
	// Application NodesɈȉ̓eǉĉ
	// DeviceListActivity(Activity)

	// ActivityNGXgR[h
	private static final int REQUEST_CODE_FIND = 0;
	private static final int REQUEST_CODE_ENABLE = 1;

	// nhbZ[W
	public static final int MESSAGE_STATE = 0;
	public static final int MESSAGE_READ = 1;

	// BluetoothA_v^[
	private BluetoothAdapter bluetoothAdapter;

	// BluetoothʐMNX
	private BluetoothConnection bluetoothConnection;

	// bZ[W
	private EditText editText;
	// M{^
	private Button sendButton;
	// BluetoothL{^
	private Button discoverableButton;
	// {^
	private Button searchButton;
	// eLXgr[
	private TextView textView;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		// BluetoothA_v^[̃IuWFNg擾܂
		bluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

		// bZ[W͗pEditTextIuWFNg擾܂
		editText = new EditText(this);

		// M{^̃IuWFNg擾܂
		sendButton = new Button(this);
		sendButton.setText("send");
		sendButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					// bZ[W𑗐M܂
					String message = editText.getText().toString();
					bluetoothConnection.write(message.getBytes());
					editText.setText(message);
				} catch (Exception e) {
					Toast.makeText(v.getContext(), "bZ[W̑MɎs܂",
							Toast.LENGTH_LONG).show();
				}
			}
		});

		// BluetoothL{^̃IuWFNg擾܂
		discoverableButton = new Button(this);
		discoverableButton.setText("discoverable");
		discoverableButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// LCegN܂
				if (bluetoothAdapter.getScanMode() != BluetoothAdapter.SCAN_MODE_CONNECTABLE_DISCOVERABLE) {
					Intent discoverableIntent = new Intent(
							BluetoothAdapter.ACTION_REQUEST_DISCOVERABLE);
					discoverableIntent.putExtra(
							BluetoothAdapter.EXTRA_DISCOVERABLE_DURATION, 300);
					startActivity(discoverableIntent);
				}
			}
		});

		// {^̃IuWFNg擾܂
		searchButton = new Button(this);
		searchButton.setText("search");
		searchButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// CegN܂
				Intent serverIntent = new Intent(v.getContext(),
						DeviceListActivity.class);
				// AREQUEST_CODE_FINDn悤ɃANeBreB[X^[g܂
				startActivityForResult(serverIntent, REQUEST_CODE_FIND);
			}
		});

		// eLXgr[̃IuWFNg擾܂
		textView = new TextView(this);
		textView.setText("");

		// CAEg쐬AEditTextAButton,TextViewzu܂
		LinearLayout layout = new LinearLayout(this);
		layout.setOrientation(LinearLayout.VERTICAL);
		layout.addView(editText, 0);
		layout.addView(sendButton, 1);
		layout.addView(discoverableButton, 2);
		layout.addView(searchButton, 3);
		layout.addView(textView, 4);
		setContentView(layout);

	}

	@Override
	public void onStart() {
		super.onStart();
		if (!bluetoothAdapter.isEnabled()) {
			// BluetoothLCegN܂
			Intent bluetoothEnableIntent = new Intent(
					BluetoothAdapter.ACTION_REQUEST_ENABLE);
			startActivityForResult(bluetoothEnableIntent, REQUEST_CODE_ENABLE);
		} else {
			if (bluetoothConnection == null)
				bluetoothConnection = new BluetoothConnection(this, handler);
		}
	}

	@Override
	public synchronized void onResume() {
		super.onResume();
		if (bluetoothConnection != null) {
			if (bluetoothConnection.getState() == BluetoothConnection.NONE) {
				bluetoothConnection.start();
			}
		}
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		if (bluetoothConnection != null)
			bluetoothConnection.stop();
	}

	// BluetoothConnectionŎ󂯎郁bZ[Wsnh
	private final Handler handler = new Handler() {
		@Override
		public void handleMessage(Message message) {
			switch (message.what) {
			case MESSAGE_STATE:
				// ԑJڂ̃bZ[W擾ꍇ
				// ԂɑΉeLXg\܂
				switch (message.arg1) {
				case BluetoothConnection.NONE:
					textView.setText("ڑĂ܂");
					break;
				case BluetoothConnection.LISTEN:
					textView.setText("ڑĂ܂");
					break;
				case BluetoothConnection.CONNECTING:
					textView.setText("ڑł");
					break;
				case BluetoothConnection.CONNECTED:
					textView.setText("ڑ܂");
					break;
				}
				break;
			case MESSAGE_READ:
				// ǂݍ݃bZ[W擾ꍇ
				// 擾f[^𕶎ɕϊĕ\܂
				byte[] readBuf = (byte[]) message.obj;
				editText.setText(new String(readBuf, 0, message.arg1));
				break;
			}
		}
	};

	// ANeBreBAɕԂlɂ鏈s܂
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
		case REQUEST_CODE_FIND:
			// ̕As܂
			if (resultCode == Activity.RESULT_OK) {
				String address = data.getExtras().getString(
						DeviceListActivity.EXTRA_DEVICE_ADDRESS);
				// Bluetooth̐ڑv(NCAg)
				BluetoothDevice device = bluetoothAdapter
						.getRemoteDevice(address);
				bluetoothConnection.connect(device);
			}
			break;
		case REQUEST_CODE_ENABLE:
			// BluetoothL̕As܂
			if (resultCode == Activity.RESULT_OK) {
				bluetoothConnection = new BluetoothConnection(this, handler);
			} else {
				Toast.makeText(this, "Bluetoothł", Toast.LENGTH_SHORT)
						.show();
				finish();
			}
		}
	}

}
