//  
//  SoftBank X}[gtHT[rXJxTCg
//  t@XR[h12(Bluetooth)
//
//  Copyright(c) 2011 SOFTBANK MOBILE Corp. All rights reserved
//

package com.example.bluetoothsample;

import java.util.Set;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

public class DeviceListActivity extends Activity implements
		AdapterView.OnItemClickListener {
	public static String EXTRA_DEVICE_ADDRESS = "device_address";

	private BluetoothAdapter bluetoothAdapter;
	private ArrayAdapter<String> devices;

	@Override
	protected void onCreate(Bundle bundle) {
		super.onCreate(bundle);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setResult(Activity.RESULT_CANCELED);

		LinearLayout layout = new LinearLayout(this);
		layout.setOrientation(LinearLayout.VERTICAL);
		setContentView(layout);

		devices = new ArrayAdapter<String>(this, R.layout.rowdata);

		// Xgr[쐬܂
		ListView listView = new ListView(this);
		listView.setLayoutParams(new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.FILL_PARENT,
				LinearLayout.LayoutParams.WRAP_CONTENT));
		listView.setAdapter(devices);
		layout.addView(listView);
		listView.setOnItemClickListener(this);

		// [TV[o[o^܂
		IntentFilter filter;
		filter = new IntentFilter(BluetoothDevice.ACTION_FOUND);
		registerReceiver(receiver, filter);
		// o^ς݂̒[郌V[o[o^܂
		filter = new IntentFilter(BluetoothAdapter.ACTION_DISCOVERY_FINISHED);
		registerReceiver(receiver, filter);

		// BluetoothAdapter擾܂
		bluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

		// 擾ς݂̃foCX擾܂
		Set<BluetoothDevice> pairedDevices = bluetoothAdapter
				.getBondedDevices();

		// foCX̐ArrayAdapter̗ǉ܂
		if (pairedDevices.size() > 0) {
			for (BluetoothDevice device : pairedDevices) {
				devices.add(device.getName() + "\n" + device.getAddress());
			}
		}
		if (bluetoothAdapter.isDiscovering())
			bluetoothAdapter.cancelDiscovery();
		bluetoothAdapter.startDiscovery();
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		if (bluetoothAdapter != null)
			bluetoothAdapter.cancelDiscovery();
		this.unregisterReceiver(receiver);
	}

	public void onItemClick(AdapterView<?> av, View v, int arg2, long arg3) {
		// Bluetooth[̌I܂
		bluetoothAdapter.cancelDiscovery();

		// IꂽBluetooth[MACAhX擾܂
		String info = ((TextView) v).getText().toString();
		String address = info.substring(info.length() - 17);
		// 擾AhXʂƂĕێCeg쐬܂
		Intent intent = new Intent();
		intent.putExtra(EXTRA_DEVICE_ADDRESS, address);
		// ʂANeBreB[Jn܂
		setResult(Activity.RESULT_OK, intent);
		finish();
	}

	private final BroadcastReceiver receiver = new BroadcastReceiver() {
		// Bluetooth[ʂ擾܂
		@Override
		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();

			if (BluetoothDevice.ACTION_FOUND.equals(action)) {
				// Bluetooth[𔭌ꍇ̏s܂
				BluetoothDevice device = intent
						.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
				if (device.getBondState() != BluetoothDevice.BOND_BONDED) {
					// o^ς݂łȂ΃Xgɒǉ܂
					devices.add(device.getName()
							+ System.getProperty("line.separator")
							+ device.getAddress());
				}
			} else if (BluetoothAdapter.ACTION_DISCOVERY_FINISHED
					.equals(action)) {
			}
		}
	};
}
